#!/usr/bin/perl -- # -*- perl -*-

$cgidir = '/var/www/htdocs/eepeter/cgi-bin';

use lib "$cgidir", "$cgidir/blib/lib",
    "$cgidir/blib/arch";


use GD;
use CGI;

require "codelib.pl";

$query = new CGI;

$width = $query->param('width');

#print STDERR $query->param('ctext');

if ($query->param('encoding') eq "autodetect") {
    @guesses = codeguess($query->param('ctext'));
    if ($guesses[0] eq "big5") {
	$query->param('encoding', "big5");
    } elsif ($guesses[0] eq "gb") {
	$query->param('encoding', "gb");
    } elsif ($guesses[0] eq "utf8") {
	$query->param('encoding', "utf8");
    } else {
        print "Content-type: text/plain\n\nUnknown encoding.  Please select GB, Big5, or UTF-8\n";
        exit;
    }
}

if ($query->param('encoding') eq "big5") {
    &initB5;
} elsif ($query->param('encoding') eq "gb") {
    &initGB;
} else {
#    print STDERR "\nUTF selected.\n";
}


$maxcol = 0;
$maxrow = 0;

# find dimensions
@lines = split(/\n/, $query->param('ctext'));
#print STDERR "number of lines: " , $#lines, "\n";
$maxrow = $#lines + 1;
foreach $line (@lines) {
    if (length($line) > $maxcol) {
	$maxcol = length($line);
    }
}

#print STDERR "maxcol is $maxcol\n";

# Initialize the GIF values

$im = new GD::Image($width*2 + ($maxcol * $width / 2), $width*2 + ($maxrow * $width) + 
		    ($maxrow * ($width/2)));

($red, $green, $blue) = split(/,/, $query->param('bgcolor'));
$bgcolor = $im->colorAllocate($red, $green, $blue);
($red, $green, $blue) = split(/,/, $query->param('fgcolor'));
$fgcolor = $im->colorAllocate($red, $green, $blue);

if ($query->param('trans') eq "yes") {
    $im->transparent($bgcolor);
} 

if ($query->param('inter') eq "yes") {
    $im->interlaced('true');
}



if ($width == 16) {
    open(UFONT, "$cgidir/fonts/UniHan16.bin") || die "File prob: $!";
    open(WFONT, "$cgidir/fonts/Wide16.bin") || die "File prob: $!";
} else {
    open(UFONT, "$cgidir/fonts/UniHan24.bin") || die "File prob: $!";
    open(WFONT, "$cgidir/fonts/Wide24.bin") || die "File prob: $!";
}

$cdim = $width;
$offsetbytes = ($cdim * $cdim) / 8;

# Draw the image
$currentrow = 1;
foreach $line (@lines) {
    if ($currentrow == 31) {last;}
    $linelen = length($line);
    for ($i = 0; $i < $linelen; $i++) {
	$char = substr($line, $i, 1);
	if (unpack("C", $char) <= 127) {
	    $im->char(gdLargeFont, $cdim + $i * ($cdim/2),$currentrow * ($cdim + $cdim/2),
		      $char, $fgcolor);
	} else {
	    if ($query->param('encoding') eq "utf8") {
		$charthree = substr($line, $i+2, 1);
		if ((unpack("C", $charthree) & 0xC0) == 0x80) {
		    $char = substr($line, $i, 3);
		    $addval = 2;
		} else {
		    $char = substr($line, $i, 2);
		    $addval = 1;
		}
	    } else {
		$char = substr($line, $i, 2);
		$addval = 1;
	    }

	    $offset = &unival($char); 
	    if ($offset >= 0x4e00 && $offset <= 0x9fa5) {
		$offset -= 0x4e00;
		$offset *= $offsetbytes;
		seek(UFONT, $offset, 0);
		$bytesread = read(UFONT, $cbytes, $offsetbytes);
	    } elsif ($offset > 0xff00 && $offset < 0xff5f) {
		$offset -= 0xff01;
		$offset *= $offsetbytes;
		seek(WFONT, $offset, 0);
		$bytesread = read(WFONT, $cbytes, $offsetbytes);
	    } else {
		$cbytes = "";	# zero out unknown characters		
	    }

	    if ($cdim == 16) {
		$binary = unpack("B256", $cbytes);
	    } else {
		$binary = unpack("B576", $cbytes);
	    }
	    # print STDERR "$binary\n";
	    for ($j = 0; $j < $cdim; $j++) {
		for ($k = 0; $k < $cdim; $k++) {
		    if (substr($binary, $j * $cdim + $k, 1) eq "1") {
			#print STDERR "Setting y ",$currentrow*$cdim+$j ," x ", $cdim+$k+$cdim*$i ,"\n";
			$im->setPixel($cdim+$k + ($cdim/2) * $i, $currentrow * ($cdim+$cdim/2) 
				      +$j, $fgcolor); 
		    }
		}
	    }
	    $i += $addval;			   
	}
    }
    $currentrow++;
}

#print "Content-type: text/plain\n";
#print "Doing repairs right now.  Sorry.\n";
#print "String length: " . length($query->param('ctext')) . "\n";
#print "width: " . $query->param('width') . "\n";
#print "bgcolor: " . $query->param('bgcolor') . "\n";
#print "fgcolor: " . $query->param('fgcolor') . "\n";
#print $query->param('ctext');


print "Content-type: image/gif\n\n";
#print "Expires: Fri, 22 May 1998 04:00:00 GMT\n";
#print "Cache-control: no-cache, max-age=0, proxy-revalidate, no-store\n\n";
print $im->gif;


sub initB5 {
    open(B5UNI, "BIG5.TXT") || die "Unable to open BIG5.TXT $!\n";
    while ($line = <B5UNI>) {
	if ($line =~ m/^#/) { 
	    next;
	}
	chop($line);
	($b5char, $unichar, $rest) = split(/\t/, $line);
	$hex = $b5char;
	$hex =~ s/^0x(....)/\1/;
	$byte1 =  "0x" . substr($hex, 0, 2);
	$bv1 = oct($byte1);
	$byte2 =  "0x" . substr($hex, 2, 2);
	$bv2 = oct($byte2);
	$char = pack("C2", $bv1, $bv2);

#	$unichar =~ s/^0x(....)/\1/;
	$orig2uni{$char} = $unichar;
    }
    close(B5UNI);
}

sub initGB {
    open(GBUNI,"GB2312.TXT") || die "Unable to open GB2312.TXT $!\n";
    while ($line = <GBUNI>) {
	if ($line =~ m/^#/) { 
	    next;
	}
	($gbchar, $unichar, $rest) = split(/\t/, $line);
	$hex = $gbchar;
	$hex =~ s/^0x(....)/\1/;
	$byte1 =  "0x" . substr($hex, 0, 2);	
	$bv1 = oct($byte1) + 0x80;
	$byte2 =  "0x" . substr($hex, 2, 2);
	$bv2 = oct($byte2) + 0x80;
	$char = pack("C2", $bv1, $bv2);
#	$unichar =~ s/^0x(....)/\1/;
	$orig2uni{$char} = $unichar;
    }
    close(GBUNI);
}


sub unival {
    local($charval) = @_;
    if ($query->param('encoding') eq "utf8") {
	if (length($charval) == 2) {
#	    print STDERR "char val : $charval\n";
	    $char1 = substr($charval, 0, 1);
	    $char2 = substr($charval, 1, 1);
	    $int1 = unpack(C, $char1);
	    $int1 &= 31;
	    $int1 <<= 6;
#	    print STDERR "\$int1 after shift is $int1\n";
	    $int2 = unpack(C, $char2);
	    $int2 &= 63;
#	    print STDERR "int2 after and is $int2\n";
	    $retval = $int1 | $int2;
	} else {
	    $char1 = substr($charval, 0, 1);
	    $int1 = unpack(C, $char1);
	    $char2 = substr($charval, 1, 1);
	    $int2 = unpack(C, $char2);
	    $char3 = substr($charval, 2, 1);
	    $int3 = unpack(C, $char3);

	    $int1 &= 0x0F;
	    $int1 <<= 12;
	    $int2 &= 0x3F;
	    $int2 <<= 6;
	    $int3 &= 0x3F;
	    $retval = $int1 | $int2 | $int3;
	}
    } else {
	$retval = oct($orig2uni{$charval});
    }
#    print STDERR "$charval : $retval\n";
    $retval;
}






